#!/usr/bin/perl
# Copyright 2013-2016 all contributors <meta@public-inbox.org>
# License: AGPL-3.0+ <https://www.gnu.org/licenses/agpl-3.0.txt>
#
# Note: this may be rewritten in another language in the future,
# so don't depend on any public Perl API
use strict;
use ExtUtils::MakeMaker;
my @EXE_FILES = split("\n", `git ls-files 'script/' 2>/dev/null`);
my $PM_FILES = `git ls-files lib '*.pm' 2>/dev/null`;
$PM_FILES =~ tr/\n/ /;

WriteMakefile(
	NAME => 'ssoma',
	VERSION => '0.2.0',
	AUTHOR => 'Eric Wong <e@80x24.org>',
	ABSTRACT => 'some sort of mail archiver',
	EXE_FILES => \@EXE_FILES,
	PREREQ_PM => {
		# Keep this sorted and synced to the INSTALL document
		'Digest::SHA' => 0,
		'Email::Address' => 0,
		'Email::LocalDelivery' => 0,
		'Email::MIME' => 0,
		'IPC::Run' => 0,
		'File::Path::Expand' => 0,
		'Net::IMAP::Simple' => 0,
	},
);

sub MY::postamble {
  <<EOF;
-include Documentation/include.mk
N := \$(shell echo \$\$(( \$\$(nproc 2>/dev/null || echo 2) + 1)))
my_syntax := \$(addsuffix .syntax, $PM_FILES \$(EXE_FILES))

%.syntax ::
	@\$(PERL) -I lib -c \$(subst .syntax,,\$@)

syntax:: \$(my_syntax)


check:: pure_all
	prove -lv -j\$(N)

EOF
}
